<template>
	<xn-form-container
		:title="formData.id ? '调整预约时段' : '调整预约时段'"
		:width="700"
		v-model:open="open"
		:destroy-on-close="true"
		@close="onClose"
	>
		<a-form ref="formRef" :model="formData" :rules="formRules" :wrapper-col="wrapperCol" :label-col="labelCol">
			<a-form-item label="订单信息：" name="orderId">
				<a-select v-model:value="formData.orderId" placeholder="请选择订单信息"
						  :options="orderIdList" disabled
				> </a-select>
			</a-form-item>
			<a-form-item label="车牌号：" name="licenseNumber">
				<a-input v-model:value="formData.licenseNumber" placeholder="请输入车牌号" allow-clear  disabled/>
			</a-form-item>
			<a-form-item label="预约时段：" name="timeId">
				<a-select v-model:value="formData.timeId" placeholder="请选择预约时段"
						  :options="timeIdList"
				> </a-select>
			</a-form-item>
			<a-form-item label="司机姓名：" name="driverName">
				<a-input v-model:value="formData.driverName" placeholder="请输入司机姓名" allow-clear disabled/>
			</a-form-item>
			<a-form-item label="司机电话：" name="driverMobile">
				<a-input v-model:value="formData.driverMobile" placeholder="请输入司机电话" allow-clear disabled/>
			</a-form-item>
		</a-form>
		<template #footer>
			<a-button style="margin-right: 8px" @click="onClose">关闭</a-button>
			<a-button type="primary" @click="onSubmit" :loading="submitLoading">保存</a-button>
		</template>
	</xn-form-container>
</template>

<script setup name="bizAppointmentRecordForm">
	import { cloneDeep } from 'lodash-es'
	import { required } from '@/utils/formRules'
	import bizAppointmentRecordApi from '@/api/biz/bizAppointmentRecordApi'
	import bizAppointmentTimeApi from "@/api/biz/bizAppointmentTimeApi";
	import bizOrderApi from '@/api/biz/bizOrderApi'

	// 抽屉状态
	const open = ref(false)
	const emit = defineEmits({ successful: null })
	const formRef = ref()
	// 表单数据
	const formData = ref({})
	const submitLoading = ref(false)
	const orderIdList = ref()
	const timeIdList = ref()

	//设置表单样式
	const labelCol = ref({ span: 5})
	const wrapperCol = ref({ span: 16})

	// 打开抽屉
	const onOpen = (record) => {
		open.value = true
		if (record) {
			let recordData = cloneDeep(record)
			formData.value = Object.assign({}, recordData)
		}

		//查询订单信息
		bizOrderApi.getList().then((res)=>{
			orderIdList.value = res.map((item)=>{
				return{
					value:item.id,
					label:item.orderName + '-' + item.orderNumber
				}
			})
		})

		//查询预约时段下拉
		bizAppointmentTimeApi.getDownList().then((res)=>{
			timeIdList.value = res.map((item)=>{
				return{
					value:item.id,
					label:item.beginTime + '-' + item.endTime
				}
			})
		})
	}
	// 关闭抽屉
	const onClose = () => {
		formRef.value.resetFields()
		formData.value = {}
		open.value = false
	}
	// 默认要校验的
	const formRules = {
		orderId: [required('请选择订单信息')],
		licenseNumber: [required('请输入车牌号')],
		timeId: [required('请选择预约时段')],
	}
	// 验证并提交数据
	const onSubmit = () => {
		formRef.value
			.validate()
			.then(() => {
				submitLoading.value = true
				const formDataParam = cloneDeep(formData.value)
				bizAppointmentRecordApi
					.bizAppointmentRecordSubmitForm(formDataParam, formDataParam.id)
					.then(() => {
						onClose()
						emit('successful')
					})
					.finally(() => {
						submitLoading.value = false
					})
			})
			.catch(() => {})
	}
	// 抛出函数
	defineExpose({
		onOpen
	})
</script>
